#include <hc11.h>
#include <mboard.h>
#define WANT_SERVOS
#include <mbintsvc.h>
/*
 * Very simple ping function. This function will tell the sonar module
 * to take a reading and return the result.
 */

int
ping()
{
	int	samp[4], res, i, mx, mn;

	mx = mn = 0;
	for (i=0; i<4; i++) {
		samp[i] = 0;
		PORTD |= 8;	/* take init high */
		/* wait for echo */
		while (((PORTD & 4) == 0) && (samp[i] < 2000))
		samp[i]++;
		PORTD &= ~8;
		if (samp[i] < samp[mn]) mn = i;
		if (samp[i] > samp[mx]) mx = i;
	}
	for (i=0, res = 0; i<4; i++) {
		if ((i == mn) || (i == mx))
			continue;
		res = res + samp[i];
	}
	return (res >> 1);
}

#define JOG_TURN 100
#define JOG_FWD 150
/*
 * 0x80, 0x40 - left motor?
 * 0x20, 0x10 - right motor?
 */
void jog_right() {
	PORTC = 0x80 + 0x10;
	msleep(JOG_TURN);
	PORTC = 0;
}

void jog_left() {
	PORTC = 0x40 + 0x20;
	msleep(JOG_TURN);
	PORTC = 0;
}

void jog_forward() {
	PORTC = 0x80 + 0x20;
	msleep(JOG_FWD);
	PORTC = 0;
}

void jog_backward() {
	PORTC = 0x40 + 0x10;
	msleep(JOG_FWD);
	PORTC = 0;
}

int new_pos(int i, int dirvec) {
	if (dirvec == 1) {
	    return (i - 100);
	} else
	    return (100 - i);
}

main()
{
	int	i, j;
	int	dir;
	int	minpos, minval;
	int	dirvec;

	DDRD |= 8;
	PORTC = 0;
	DDRC = 0xf0;
	dirvec = 1;
	while (1) {
	    minval = 3000;
	    minpos = 0;
	    for (i = 0; i < 200; i += 7) {
		servo(1, new_pos(i, dirvec));
		msleep(100);
		servo_off(1);
		j = ping();
		if (j < minval) {
		    minval = j;
		    minpos = i;
	        }
		puts("Position ");
		numout(i);
		puts(", dist=");
		printdec(j);
	    }
	    dirvec = (dirvec == 1) ? -1 : 1;
	    servo(1, minpos);
	    msleep(450);
	    servo_off(1);
	    if (minpos < -10) {
		jog_left();
	    } else if (minpos > 10) {
		jog_right();
	    } else jog_backward();
	    msleep(1000);
	}
}
