/*
 * cougar.c
 *
 * This module has the main control program for the Wild Cougar robot
 * 
 *
 */
#include <hc11.h>
#include <mboard.h>
#define WANT_BUTTON
#define USER_INIT
#define DOUSERINT
#include <mbintsvc.h>

extern void do_cmotors();
/*
 * This is called every millsecond by the tick subroutine
 */
void
do_userint()
{
	do_cmotors();
}

/*
 * This is the maximum speed of the motor in ticks/sample. It was 
 * determined empirically by setting the setpoint to be 100 and
 * watching the process variable to see how high it got with the
 * motor at maximum.
 */
#define MAX_MOTOR_SPEED 14
extern unsigned char motor_ctl;
extern unsigned int speed[];

user_init()
{
	DDRC = 0xf0;	/* Port C is 1/2 an output */
	motor_ctl = 0;
	speed[0] = speed[1] = -1;
	return 0;
}

/*
 * This is the main function and it is designed to run the motors at
 * "stop" , 25% speed, 50% speed, 75% speed, and 100% speed. If this
 * were a navy boat that would be slow, cruise, full, and flank speed.
 *
 */

void
main()
{
	int	speed_delta = MAX_MOTOR_SPEED / 4;
	int	i, set_speed = 0;

	while (1) {
		for (i = 0; i < 17; i++) {
			cmotor(1, i);
			msleep(1000);
		}
	}
}
